/*
 * Copyright (c) 2008, Noel Lemouel
 * All rights reserved. See LICENCE file for details.
 */

#include <asm/mmap.h>

	.text
	.global _prolog

_prolog:

	b _rs_init

	/* . = 0x... */

/* word aligned */

_rs_init:

	.set noat
	.set noreorder

	xor $zero, $zero, $zero	/* r0 = 0 */

	/* ICACHE INIT */

	/* flush and disable instruction cache if enabled */

	/* DCACHE INIT */

	/* flush and disable data cache if enabled */

	/* disable exceptions & interrupts */

	/* ... */

	/* RELOCATE CODE & DATA */

	/* ... */

	/* binary load in ram at exec location / no need for relocation now */

	/* ZERO BSS/SBSS -- bss and sbss are assumed to be adjacent
	 * and between __bss_start and _end.
	 */

	lui  $v0, %hi(__bss_start)
	ori  $v0, $v0, %lo(__bss_start)
	lui  $v1, %hi(_end)
	ori  $v1, $v1, %lo(_end)
	beq  $v0, $v1, _1
	nop
_0:	sw   $zero, 0($v0)
	addi $v0, $v0, 4
	beq  $v0, $v1, _1
	nop
	j _0
	nop
_1:

	/* JUMP TO RELOC ADDR */

	/* ... */

	/* COPY EXCEPTION ROUTINE(S) */

	/* ... */

	/* STACK INIT */

	lui $sp, %hi(0xa0000800)
	addiu $sp, $sp, %lo(0xa0000800)

	/*
	 * Call tiny -- never returns
	 */

	j tiny
	nop

	/* NEVER RETURNS -- but branch to the _prolog just
	 * in case ;-)
	 */
	j _prolog
	nop

	.globl	_version

_version:
	.ascii "TINY"
	.ascii " (", __DATE__, " - ", __TIME__, ")", "\n\0"

