/*
 * Copyright (c) 2012, Noel Lemouel
 * All rights reserved.
 */

#include <sysutil.h>

#include <pic32-io.h>
#include <drivers/led/led.h>
#include <drivers/i2c-gpio/i2c-gpio.h>

#include <ush/ush.h>

void tiny(void)
{
   volatile unsigned int i;

   i2c_gpio_channel_data_t i2c_gpio_channel_00;

   /* UART1 already initialized by serial loader */
   /* uart1_init(); */

   led_init();

   printf("tiny mips [pic32_experimental_000]\n");  

   /* i2c */

   gpio_init(0, PORTB_BASE);
   gpio_init(1, PORTB_BASE);

   i2c_gpio_channel_00.gpio_base = PORTB_BASE;
   i2c_gpio_channel_00.scl_pin = 0;
   i2c_gpio_channel_00.sda_pin = 1;
   i2c_gpio_channel_00.udelay = 0;
   i2c_gpio_channel_00.timeout = 100;

   i2c_set_channel(&i2c_gpio_channel_00);

   /* ush */

   ush();

   /* leds */

   for(;;)
   {
      led0_set();
      led1_set();
      led2_set();
      i = 80000; while(i--);
      led0_clear();
      led1_clear();
      led2_clear();
      i = 80000; while(i--);
   }
}

