/*
 * Copyright (c) 2012, Noel Lemouel
 * All rights reserved.
 */

#include <sysutil.h>
#include <string.h>

/* peek = memory read 8/16/32 value (default = 32) */
/* peek [8/16/32] [MEM] */

static void usage(void)
{
   printf("usage: peek [8/16/32] [MEM]\n");
}

int _peek(int argc, char **argv)
{
   unsigned char* p8;
   unsigned short* p16;
   unsigned int* p32;

   if(argc == 2){
      p32 = (unsigned int*)atox(argv[1]);
      printf("0x%08x\n", *p32);
   }else if(argc == 3){
      if(!strcmp("8", argv[1]))
      {
         p8 = (unsigned char*)atox(argv[2]);
         printf("0x%02x\n", *p8 & 0xff);
      }else if(!strcmp("16", argv[1]))
      {
         p16 = (unsigned short*)atox(argv[2]);
         printf("0x%04x\n", *p16 & 0xffff);
      }else if(!strcmp("32", argv[1]))
      {
         p32 = (unsigned int*)atox(argv[2]);
         printf("0x%08x\n", *p32);
      }else{
         usage();
      }
   }else{
      usage();
   }

   return 0;
}

