/*
 * Copyright (c) 2012, Noel Lemouel
 * All rights reserved.
 */

#include <sysutil.h>
#include <string.h>

/* peek = memory read 8/16/32 value (default = 32) */
/* peek [8/16/32] [MEM] */

static void usage(void)
{
   printf("usage: poke [8/16/32] [MEM] [VAL]\n");
}

int _poke(int argc, char **argv)
{
   unsigned char* p8;
   unsigned short* p16;
   unsigned int* p32;

   if(argc == 3){
      p32 = (unsigned int*)atox(argv[1]);
      *p32 = atox(argv[2]);
   }else if(argc == 4){
      if(!strcmp("8", argv[1]))
      {
         p8 = (unsigned char*)atox(argv[2]);
         *p8 = (unsigned char)atox(argv[3]);
      }else if(!strcmp("16", argv[1]))
      {
         p16 = (unsigned short*)atox(argv[2]);
         *p16 = (unsigned short)atox(argv[3]);         
      }else if(!strcmp("32", argv[1]))
      {
         p32 = (unsigned int*)atox(argv[2]);
         *p32 = (unsigned int)atox(argv[3]);
      }else{
         usage();
      }
   }else{
      usage();
   }

   return 0;
}

